/*
	FileList 1.4
	"Search.h"
*/

typedef Byte FILENAME[32];	/* Length byte and 31 characters */
typedef Byte VOLNAME[28];	/* Length byte and 27 characters */

enum {			/* Kinds of info records */
	VOLUME,
	FOLDER,
	FILE };

typedef struct {			/* All that is stored for each file: */
	short kind;				/* - kind of record */
	long parent;			/* - parent pointer */
	long volume;			/* - volume pointer */
	long size;				/* - size (volume: total space) */
	long cdate;				/* - creation date */
	long mdate;				/* - modification date */
	long type;				/* - type (volume: free space) */
	long creator;			/* - creator (volume: files) */
	Byte name[];			/* - its name */
} FileInfo, *FileInfoPtr, **FileInfoHdl;

FileInfoPtr Address (WindowDataPtr, long);
void AddVolumes (void);
void Again (void);
void DeleteVolume (void);
void DisposeMemory (void);
void Find (void);
Boolean FindVolume (Byte *, unsigned long *);
Byte *GetVolume (FileInfoPtr);
void InitPath (FileInfoPtr, STACK *);
void KillVolume (HVolumeParam *);
short NewMemory (unsigned long, unsigned short, unsigned short, unsigned short);
Byte *NextPath (STACK *);
void NoSort (void);
void RenameVolume (void);
short SearchVol (short, Boolean);
void Select (WindowDataPtr, long, Boolean);
Boolean Selected (WindowDataPtr, long);
void Toggle (WindowDataPtr, long);
